import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Test;

class BuyOrderTest {

	@Test
	void buyTradeTest() {
		Customer c = new Customer("c1");
		Stock stock = new Stock("Apple");
		BuyOrder buyOrder = new BuyOrder(1, c, stock, 100, 200);
		assertEquals(buyOrder.getCustomer().getId(), c.getId());
		assertEquals(buyOrder.getPrice(), 200);
		assertEquals(buyOrder.getQty(), 100);
		assertEquals(buyOrder.getTime(), 1);
		assertEquals(buyOrder.getType(), "BUY");
		assertEquals(buyOrder.getStock().getName(), "Apple");
	}
	
	@Test
	void equalityTest() {
		Customer c1 = new Customer("c1");
		Customer c2 = new Customer("c2");
		Stock s1 = new Stock("Apple");
		Stock s2 = new Stock("Google");
		BuyOrder bt1 = new BuyOrder(1, c1, s1, 100, 200);
		SellOrder st1 = new SellOrder(1, c1, s1, 100, 200);
		
		// checking if a two objects created with exact same arguments
		// are indeed equal
		assertEquals(new BuyOrder(1, c1, s1, 100, 200), bt1);
		assertNotEquals(new BuyOrder(1, c1, s1, 100, 300), bt1);
		
		// checking SellTrade and BuyTrade are not equal
		assertNotEquals(bt1, st1);
	}

}
